#
# spec file for package mysql
#
# Copyright (c) 2013 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


# Few definitions which will alter build
%define prefered   0
%define use_cmake  1
%define cluster    0
%define builtin_plugins partition,csv,heap,myisam,innobase
%define use_extra_provides 0
%define extra_provides mysql-community-server_55

%if %{?rel:0}%{!?rel:1}
%define rel 1
%endif
#Distribution:   %dist
#Packager:       %packager
#Vendor:         %vendor

Name:           mysql
Summary:        Server part of MySQL Community Server
License:        SUSE-GPL-2.0-with-FLOSS-exception
Group:          Productivity/Databases/Servers
Version:        5.5.30
Release:        20.1
%define srv_vers 5.5.30
%define toku_vers 7.1.0
Url:            http://www.mysql.com
Source:         mysql-%{version}-tokudb-%{toku_vers}.tar.bz2
Source2:        baselibs.conf
Source3:        README.debug
Source4:        suse-test-run
Source5:        mysql.SuSEfirewall2
Source7:        rc.mysql-multi
Source8:        README.SuSE
Source9:        mysql-patches.tar.bz2
Source10:       build.inc
Source11:       install.inc
Source12:       series
Source13:       configuration-tweaks.tar.bz2
Source14:       update-message
Patch0:         mysql-5.5.30-TYPE-support.patch
Patch1:         mysql-5.5.31-upgrade-datadir.patch
Patch2:		mysql-5.5.30-tokudb-7.1.0_RPATH.patch
Patch3:		mysql-5.5.30-tokudb-7.1.0_CMAKEDEBUG.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
%if 0%{?suse_version}
PreReq:         pwdutils
PreReq:         %install_info_prereq %insserv_prereq
%endif
BuildRequires:  autoconf
BuildRequires:  automake
BuildRequires:  bison
BuildRequires:  cmake
BuildRequires:  gcc-c++
BuildRequires:  libtool
BuildRequires:  ncurses-devel
BuildRequires:  openssl-devel
BuildRequires:  pam-devel
BuildRequires:  procps
BuildRequires:  readline-devel
BuildRequires:  zlib-devel
BuildRequires:	jemalloc-devel
%if 0%{?suse_version}
BuildRequires:  pwdutils
BuildRequires:  tcpd-devel
%endif
%if 0%{?suse_version} > 1030 || 0%{?fedora_version} > 8
BuildRequires:  fdupes
%endif
%if 0%{?fedora_version} > 11
BuildRequires:  sqlite
%endif
%if 0%{?suse_version} > 1030
Recommends:     logrotate
%else
Requires:       logrotate
%endif
# required by rcmysql
Requires:       %{name}-client = %{version}
Requires:       perl-base
Provides:       mysql-Max = %{srv_vers}
Provides:       mysql = %{srv_vers}
Provides:	mysql-tokudb = %{toku_vers}
%if 0%{?use_extra_provides} > 0
Provides:       %{extra_provides} = %{version}
Obsoletes:      %{extra_provides} < %{version}
%endif
Obsoletes:      mysql-Max < %{srv_vers}
Conflicts:      otherproviders(mysql)

%description
SQL is the most popular database language in the world. MySQL is a
client/server implementation that consists of a server daemon (mysqld)
and many different client programs and libraries.

The main goals of MySQL are speed, robustness, and ease of use. MySQL
was originally developed because the developers at TcX needed an SQL
server that could handle very large databases an order of magnitude
faster than what any database vendor could offer them. They have now
been using MySQL since 1996 in an environment with more than 40
databases containing 10,000 tables, of which more than 500 have more
than 7 million rows. This is about 100 gigabytes of mission-critical
data.

The base upon which MySQL is built is a set of routines that have been
used in a highly demanding production environment for many years. While
MySQL is still in development, it already offers a rich and highly
useful function set.

The official way to pronounce MySQL is &quot;My Ess Que Ell&quot; (Not
MY-SEQUEL). 

This package only contains the server-side programs.

%package -n libmysql55client18
Summary:        Shared Libraries for MySQL Community Server
License:        SUSE-GPL-2.0-with-FLOSS-exception
Group:          Development/Libraries/Other

%description -n libmysql55client18
This package contains the shared libraries (.so) which certain
languages and applications need to dynamically load and use MySQL Community Server.

%package -n libmysql55client_r18
Summary:        Shared Libraries for MySQL Community Server
License:        SUSE-GPL-2.0-with-FLOSS-exception
Group:          Development/Libraries/Other

%description -n libmysql55client_r18
This package contains the shared libraries (.so) which certain
languages and applications need to dynamically load and use MySQL Community Server.

%package -n libHotBackupCommunity
Summary:	TokuDB's libHotBackupCommunity
License:	SUSE-GPL-2.0-with-FLOSS-exception
Group:		Development/Libraries/Other

%description -n libHotBackupCommunity
This package contains the share librarie libHotBackupCommunity.so provided by TokuDB.

%package client

Summary:        Client for MySQL Community Server
Group:          Productivity/Databases/Clients
Provides:       mysql-client = %{srv_vers}
Provides:	mysql-client-tokudb = %{toku_vers}
%if 0%{?use_extra_provides} > 0
Provides:       %{extra_provides}-client = %{version}
Obsoletes:      %{extra_provides}-client < %{version}
%endif
Conflicts:      otherproviders(mysql-client)

%description client
This package contains the standard clients for MySQL Community Server.

%package bench

Requires:       %{name}-client perl-DBD-mysql
Summary:        Benchmarks for MySQL Community Server
Group:          Productivity/Databases/Tools
Provides:       mysql-bench = %{srv_vers}
Provides:	mysql-bench-tokudb = %{toku_vers}
%if 0%{?use_extra_provides} > 0
Provides:       %{extra_provides}-bench = %{version}
Obsoletes:      %{extra_provides}-bench < %{version}
%endif
Conflicts:      otherproviders(mysql-bench)

%description bench
This package contains benchmark scripts and data for MySQL Community Server.

To run these database benchmarks, start the script "run-all-tests" in
the directory /usr/share/sql-bench after starting MySQL Community Server.


%package debug-version

Summary:        MySQL Community Server with debug options turned on
Group:          Productivity/Databases/Servers
Requires:       %{name} = %{version}
Provides:       mysql-debug = %{srv_vers}
Provides:       %{name}-debug = %{srv_vers}
Provides:	mysql-debug-tokudb = %{toku_vers}
%if 0%{?use_extra_provides} > 0
Provides:       %{extra_provides}-debug-verion = %{version}
Obsoletes:      %{extra_provides}-debug-version < %{version}
%endif
Obsoletes:      mysql-debug < %{srv_vers}
Conflicts:      otherproviders(mysql-debug)

%description debug-version
A version of the MySQL Community Server that has some debug code turned on.
It should be only used to track down problems with the standard
servers. Note that merely installing this package will bot replace the
standard server. Read /usr/share/doc/packages/mysql/README.debug for
information on how to use the debug server.

%package test

Summary:        Testsuite for MySQL Community Server
Group:          Productivity/Databases/Servers
Requires:       %{name} = %{version}
Requires:       %{name}-client = %{version}
Requires:       perl-DBD-mysql
Requires:       %{name}-tools = %{version}
Requires:       %{name}-bench = %{version}
Provides:       mysql-test = %{srv_vers}
Provides:	mysql-test-tokudb = %{toku_vers}
%if 0%{?use_extra_provides} > 0
Provides:       %{extra_provides}-test = %{version}
Obsoletes:      %{extra_provides}-test < %{version}
%endif
Conflicts:      otherproviders(mysql-test)

%description test
This package contains the test scripts and data for MySQL Community Server.

To run the testsuite, run /usr/share/mysql-test/suse-test-run.

%package tools

Summary:        MySQL Community Server tools
Group:          Productivity/Databases/Servers
Requires:       perl-DBD-mysql
# make sure this package is installed when updating from 10.2 and older
Provides:       mysql-client:/usr/bin/perror
Provides:       mysql-tools = %{srv_vers}
Provides:	mysql-tools-tokudb = %{toku_vers}
Provides:       mysql:/usr/bin/mysqlhotcopy
%if 0%{?use_extra_provides} > 0
Provides:       %{extra_provides}-tools = %{version}
Obsoletes:      %{extra_provides}-tools < %{version}
%endif
Conflicts:      otherproviders(mysql-tools)

%description tools
A set of scripts for administering a MySQL Community Server or developing
applications with MySQL Community Server.

%prep
%setup -q -n mysql-%{version}-tokudb-%{toku_vers} -D -a 9
%patch0
%patch1
%patch2
%patch3
cd sql
yacc  -y -p MYSQL --output=sql_yacc.cc --defines=sql_yacc.h ./sql_yacc.yy 
cd ..
cp %_sourcedir/README.SuSE .
cp %_sourcedir/suse-test-run .
# apply patches from series
mysql-patches/tools/quilt-setup.sh  "%{S:12}"
mysql-patches/tools/apply-series.sh "%{S:12}"
# remove unneeded manpages ('make install' basically installs everything under
# man/*)
rm -f man/mysqlman.1        # dummy fallback manpage
[ \! -f man/CMakeLists.txt ] || sed -i 's|mysqlman.1||'     man/CMakeLists.txt
rm -f man/mysql.server.1    # init script, not installed in our rpm
[ \! -f man/CMakeLists.txt ] || sed -i 's|mysql.server.1||' man/CMakeLists.txt
rm -f man/make_win_*.1      # windows build scripts
rm -f man/comp_err.1        # built-time utility
# 5.1 Carrier Grade Edition only / still under development as of 5.1.22
rm -f man/ndbd_redo_log_reader.1
# breaks VPATH builds when in sourcedir, is generated in the builddirs
rm -f sql/sql_builtin.cc
sed -i 's|@localstatedir@|/var/log|' support-files/mysql-log-rotate.sh
%if 0%{prefered} < 1
for i in `grep -Rl mysqlclient .`; do
	sed -i 's|mysqlclient|mysql55client|g' $i
done
%endif
# Broken test that needs sources
rm -f mysql-test/t/file_contents.test mysql-test/r/file_contents.result
sed -i 's|\(SSL_set_options(.*SSL_OP_NO_COMPRESSION);\)|/*\ \1\ */|' vio/viossl.c

%build
%{expand:%(cat %_sourcedir/build.inc)}

%install
%{expand:%(cat %_sourcedir/install.inc)}

%pre
/usr/sbin/groupadd -r mysql >/dev/null 2>/dev/null || :
/usr/sbin/useradd -r -o -g mysql -u 60 -c "MySQL database admin" \
                  -s /bin/false -d /var/lib/mysql mysql 2> /dev/null || :
/usr/sbin/usermod -g mysql -s /bin/false mysql || :

#######################################################################
# preun and posttran takes care of restart                            #
#######################################################################

%preun
[ $1 = 1 ] || /usr/sbin/rcmysql stop

%pretrans -p <lua>
if posix.access("/usr/sbin/rcmysql", "x") then
  restart = os.execute("/usr/sbin/rcmysql status > /dev/null")
  os.execute("/usr/sbin/rcmysql stop")

  if restart == 0 then
    os.execute("/bin/mkdir -p /var/run/mysql/restart")
  end
end

%posttrans
%install_info --info-dir=%{_infodir} %{_infodir}/mysql.info.*
if [ -d /var/lib/mysql ]; then
	touch /var/lib/mysql/.run-mysql_upgrade
	chown -R mysql:mysql /var/lib/mysql
fi
for i in /var/lib/mysql/{.protected,.tmp}; do
	( [ -d "$i" ] && rmdir "$i" ) || :
done
# start mysql again if it should run
datadir="/var/lib/mysql"
if [ -x /usr/bin/my_print_defaults ]; then
	datadir="`/usr/bin/my_print_defaults mysqld mysql_server | sed -n 's|--datadir=||p'`"
	[ "$datadir" ] || datadir="/var/lib/mysql"
fi
if	[ -n "`ls /etc/rc.d/rc*.d/S*mysql 2> /dev/null`"		-o \
	  -d /var/run/mysql/restart ]	 				&& \
		[ -f "$datadir/mysql_upgrade_info" ]			&& \
		[ -n "`grep "^5.5" "$datadir/mysql_upgrade_info"`" ]	&& \
		[ -x /usr/sbin/rcmysql ]; then
			/usr/sbin/rcmysql start
fi
if [ -d "$datadir/mysql" ] && \
   [ -z "`grep "^5.5" "$datadir/mysql_upgrade_info"`" ]; then
cat > /var/adm/update-messages/%{name}-%{version}-%{release} << EOF
%(cat %_sourcedir/update-message)
EOF
fi
[ \! -d /var/run/mysql/restart ] || rmdir /var/run/mysql/restart

#######################################################################
# Various ldconfig post scripts                                       #
#######################################################################

%post -n libmysql55client18 -p /sbin/ldconfig

%postun -n libmysql55client18 -p /sbin/ldconfig

%post -n libmysql55client_r18 -p /sbin/ldconfig

%postun -n libmysql55client_r18 -p /sbin/ldconfig

%post -n libHotBackupCommunity -p /sbin/ldconfig

%postun -n libHotBackupCommunity -p /sbin/ldconfig

%postun
if [ $1 = 0 ]; then
	%install_info_delete --info-dir=%{_infodir} %{_infodir}/mysql.info.*
	%{insserv_cleanup}
fi

#######################################################################
# Files section                                                       #
#######################################################################

%files -f mysql.files
%defattr(-, root, root)
%config(noreplace) %attr(0640, root, mysql) /etc/my.cnf
%dir %attr(0750, root, mysql) /etc/mysql
%config(noreplace) %attr(0640, root, mysql) /etc/mysql/*
%config /etc/logrotate.d/mysql
%doc %{_defaultdocdir}/%{name}
%doc %{_infodir}/mysql.info.*
/etc/init.d/mysql
/usr/sbin/rcmysql
%ghost %dir %attr(755,mysql,mysql)/var/run/mysql
%dir %{_libdir}/mysql
%{_libdir}/mysql/mysqld.sym
%config /etc/sysconfig/SuSEfirewall2.d/services/mysql
%dir %_libdir/mysql/plugin
%_libdir/mysql/plugin/[!d]*.so
/usr/share/%{name}

%files client -f mysql-client.files
%defattr(-, root, root)
%config(noreplace) %attr(0640, root, mysql) /etc/mysqlaccess.conf

%files -n libHotBackupCommunity
%defattr(-, root, root)
%{_libdir}/libHotBackupCommunity.so

%files -n libmysql55client18
%defattr(-, root, root)
%{_libdir}/libmysql55client.so.*

%files -n libmysql55client_r18
%defattr(-, root, root)
%{_libdir}/libmysql55client_r.so.*

%files bench -f mysql-bench.files
%defattr(-, root, root)
/usr/share/sql-bench

%files debug-version
%defattr(-, root, root)
/usr/sbin/mysqld-debug
%{_libdir}/mysql/mysqld-debug.sym

%files test -f mysql-test.files
%defattr(-, root, root)
%{_bindir}/my_safe_process
%_mandir/man1/mysql-test-run.pl.1*
%_mandir/man1/mysql-stress-test.pl.1*
/usr/share/mysql-test/valgrind.supp
%dir %attr(755, root, root)/usr/share/mysql-test
/usr/share/mysql-test/[^v]*
%dir %attr(755, mysql, mysql) /usr/share/mysql-test/var

%files tools -f mysql-tools.files
%defattr(-, root, root)
%_bindir/mysqlrepair
%_bindir/mysqlanalyze
%_bindir/mysqloptimize

%changelog
* Fri Nov 22 2013 cs@linux-administrator.com
- replace mysql source with tokudb 7.1.0 source
